#!/bin/bash
# topo B-A-C creates the following network topology:
#
#
#    netns=B          netns=A         netns=C
#
#       B  --- br0 ---  A  --- br1 ---  C
#        b1           a1 a2           c1
#        B1           A1 A2           C1
#
# should be run under unshare -mrun .
# use nsenter --net={A,B,C} to enter into network namespace of A/B/C.
#
# Based on https://github.com/troglobit/smcroute/tree/master/test

touch A B C
PID=$$

ip link add br0 type bridge     # vlan_filtering 1 mcast_snooping 0
ip link add type a1 veth peer b1
ip link set b1 master br0
ip link set a1 up
ip link set b1 up
ip link set br0 up


unshare --net=B -- ip link set lo up
nsenter --net=B -- ip link add B1 type veth peer B
nsenter --net=B -- ip link set B netns $PID
ip link set B up
